(*
**
** OS.INC, Operating System  information support file
**
** Copyright (c) 1996 by Maarten Bekers
**
** Created : 16-Apr-1996
** Last update : 29-Apr-1996
**
**
*)

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function Windows95Installed: Boolean;
Begin;
 Regs.AX := $1600;
 Intr($2F, Regs);
 If NOT (Regs.AL in [$00, $01, $80, $FF]) then
  If (Regs.AL=4) then Windows95Installed := True
   else Windows95Installed := False;
End; { func. WindowsInstalled }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowOsVersion: String;
Var Temp    : String;
    OsMajor,
    OsMinor : Byte;
Begin;
 Temp:='';
 OsMajor := Lo(DosVersion);  { Use routine from DOS.TPU to get the dos-version }
 OsMinor := Hi(DosVersion);

 Regs.AX    := $4452;
 Regs.Flags := Regs.Flags AND FCarry;
 Intr($21, Regs);
 If NoCarry(Regs) then
  Begin;
   Temp := Temp + ' ' + 'DR-DOS ';
   Case Regs.AX of
     $1063: Temp := Temp + 'v3.41';
     $1065: Temp := Temp + 'v5.00';
     $1067: Temp := Temp + 'v6.00';
    Else Temp := Temp + '(unknown)';
   End; { Case }
  End; { If Not DrDos }

  If OsMajor>=10 then
   Begin;
    If (OsMajor div 10 = 03) then
     Temp := 'OS/2 v'+FStr(OsMajor div 10)+'.'+FStr(OsMinor) + ' (WARP)'
      else Temp := 'OS/2 v'+FStr(OsMajor div 10)+'.'+FStr(OsMinor)
   End { OsMajor }
    else
      If (OsMajor>6) then         { Can be PC-DOS v7.00 but also Windows '95 }
       Begin;
        If Windows95Installed then
          Temp := 'Windows 95'
           else Temp := 'PC-DOS 7.00';
       End
            else Temp := 'DOS v'+FStr(OsMajor)+'.'+FStr(OsMinor);

 ShowOsVersion := Temp;
End; { func. ShowOsVersion }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowRealVersion: String;
Begin;
 Regs.AX := $3000;
 Intr($21, Regs);
 ShowRealVersion := 'v'+FStr(Regs.AL)+'.'+FStr(Regs.AH);
End; { func. ShowRealVersion }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowOEMnumber: String;
Begin;
 Regs.AX := $3000;
 Regs.BX := 000;
 Intr($21, Regs);
 ShowOemNumber := HexByte(Regs.BH);
End; { func. ShowOemNumber }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowDate: String;
Const WeekDay: Array[0..6] of String[9] = ('Sunday', 'Monday', 'Tuesday',
                                           'Wednesday', 'Thursday', 'Friday',
                                           'Saturday');
Var Year, Month, Day, DOW: Word;
    Temp         : String;
    DateNotation : Word;
    SepChar      : Char;
Begin;
 Temp := '';
 GetDate(Year, Month, Day, Dow);
 If Dow<7 then
  Temp := Temp + WeekDay[Dow]+', ';

 SepChar := Country.DateSep[0];
 Case Country.DateFormat of
  $0001 : Temp := Temp + FStr(Day) + SepChar + FStr(Month) + SepChar +
FStr(Year);
  $0002 : Temp := Temp + FStr(Year) + SepChar + FStr(Month) + SepChar +
Fstr(Day);
   else Temp := Temp + FStr(Month) + SepChar + FStr(Day) + SepChar + FStr(Year);
 End; { Case }

 ShowDate := Temp;
End; { func. ShowDate }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowTime: String;
Var Temp : String;
    Hour, Minutes, Seconds, MSeconds: Word;
    SepChar : Char;
Begin;
 Temp := '';
 SepChar := Country.Timesep[0];
 GetTime(Hour, Minutes, Seconds, MSeconds);
 If Country.TimeFormat AND 01 = 00 then
  Case Hour of
   0      : Temp := '12';
   1..12  : Temp := FStr(Hour);
   13..23 : Temp := FStr(Hour - 12);
  End { Case }
   else Temp := FStr(Hour);

 Temp := Temp + SepChar + FStr(Minutes) + SepChar + FStr(Seconds) + '.' +
FStr(MSeconds);
 If Country.TimeFormat AND 01 = 00 then
  If Hour>11 then Temp := Temp + ' (pm)'
   else Temp := Temp + ' (am)';

 ShowTime := Temp;
End; { func. ShowTime }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function CtrlBreakState: Boolean;
Begin;
 Regs.AH := $33;
 Regs.AL := $00;
 Intr($21, Regs);
 Case Regs.DL of
   $00 : CtrlBreakState := False;
   $01 : CtrlBreakState := True;
 End; { Case }
End; { CtrlBreakState }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function VerifyState: Boolean;
Begin;
 Regs.AH := $54;
 Intr($21, Regs);
 Case regs.AL of
  $00 : VerifyState := False;
  $01 : VerifyState := True;
 End; { Case }
End; { func. VerifyState }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetReset: String;
Var StatusWord: Word;
Begin;
 StatusWord := MemW[BiosDSeg: $72];
 Case StatusWord of
   $0000  : GetReset := 'cold';
   $1234,
   $1200,
   $EDCB  : GetReset := 'Will bypass memory test';
   $4321  : GetReset := 'Preserve memory';
   $5678  : GetReset := 'System suspended';
   $9ABC  : GetReset := 'Manufacturing test mode ...';
   $ABCD  : GetReset := 'System POST (Power On Self Test) loop mode';
    else GetReset := '(unknown)';
 End; { Case }
End; { func. GetReset }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetBootDrive: Char;
Begin;
 Regs.AX := $3305;
 Intr($21, Regs);
 GetBootdrive := Chr(Regs.DL + $40);
End; { func. GetBootdrive }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetPrintScreenStatus: String;
Var Attrib: Byte;
Begin;
 Attrib := Mem[BiosDSeg: $0100];
 Case Attrib of
  $00 : GetPrintScreenStatus := 'Ready.';
  $01 : GetPrintScreenStatus := 'Busy.';
  $FF : GetPrintScreenStatus := 'Error on last PrintScreen';
   else GetPrintScreenStatus := 'Unknown...';
 End; { Case }
End; { func. GetPrintScreenStatus }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetMemoryFit: String;
Begin;
 Regs.AH := $58;
 Regs.AL := 00;
 Intr($21, Regs);
 Case Regs.AX of
   $00 : GetMemoryFit := 'Low Memory, First fit';
   $01 : GetMemoryFit := 'Low Memory, Best Fit';
   $02 : GetMemoryFit := 'Low Memory, Last Fit';
   $40 : GetMemoryFit := 'High Memory First Fit';
   $41 : GetMemoryFit := 'High Memory Best Fit';
   $42 : GetMemoryFit := 'High Memory Last Fit';
   $80 : GetMemoryFit := 'First Fit, Try High, then Low Memory';
   $81 : GetMemoryFit := 'Best Fit, Try High, then Low Memory';
   $82 : GetMemoryFit := 'Last Fit, Try High, then Low Memory'
    else GetMemoryFit := '(unknown)';
 End; { Case }
End; { func. GetMemoryFit }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowBufs(Ofs: Word): String;
Const BufsMax = 99;
var Counter  : 0..bufsmax + 1;
    Finished : Boolean;
    xword1 : word;
    xword2 : word;
    xword3 : word;
    TempStr: String;
Begin;
 TempStr := '';

 If (OsMajor < 04) OR (OsMajor >=10) then
  Begin;
   Counter := 00;
   XWord1 := MemW[DosCSeg : Ofs];
   XWord2 := MemW[DosCSeg : Ofs + 02];
   Finished := False;
   Repeat;
    If Counter <= BufsMax then
     Begin;
      If XWord1 < $FFFF then
       Begin;
        Inc(Counter);
        XWord3 := XWord1;
        XWord1 := MemW[XWord2 : XWord3];
        XWord2 := MemW[XWord2 : XWord3 + 2]
       End
        else Begin;
               Finished := True;
               TempStr := TempStr + Chr(32) + FStr(Counter);
             End; { Else }
     End { If Counter }
      else Begin;
            Finished := True;
            TempStr := TempStr + ' Unknown';
           End; { Else }
   Until Finished;
  End { if OsMajor }
   Else
    Begin;
     Regs.AX := $5200;
     Intr($21, Regs);
     TempStr := TempStr + FStr(MemW[Regs.ES:Regs.BX + $3F]);
     TempStr := TempStr + ',';
     TempStr := TempStr + ' ' + FStr(MemW[Regs.ES:Regs.BX + $41]);
     If OsMajor=04 then
      Begin;
        TempStr := TempStr + ' in EMS';
        XWord2 := MemW[Regs.ES:Regs.BX + $12];
        XWord1 := MemW[Regs.ES:Regs.BX + $14];
        Case Mem[XWord1: XWord2 + $C] of
         $00: TempStr := TempStr + ' no';
         $FF: Begin;
               TempStr := TempStr + ' yes, handle ';
               TempStr := TempStr + FStr(MemW[xword1: xword2 + $D])
              End;
         $01: If Mem[xword1: xword2 + $18] = 0 then
                 TempStr := TempStr + ' no'
               Else
                Begin;
                 TempStr := TempStr + ' yes, handle ';
                 TempStr := TempStr + FStr(MemW[xword1: xword2 + $18]);
                End;
          else TempStr := TempStr + ' Unknown';
        End; { Case }
      End; { If }
    End; { Else }
 ShowBufs := Trim(TempStr);
End; { func. ShowBufs }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetBuffers: String;
Begin;
 GetBuffers := '';
 Case OsMajor of
  03 : Case OsMinor div 10 of
            00   : GetBuffers := ShowBufs($013F);
            1..3 : GetBuffers := ShowBufs($0038);
        else GetBuffers := '(unknown)';
       End { case }
        else GetBuffers := ShowBufs(00);
 End; { Case }
End; { func. GetBuffers }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetFiles: Word;
Var FileSeg,
    FileOfs      : Word;
    Finished    : Boolean;
    FileHandles : Word;
    TempSeg ,
    TempOfs      : Word;
Begin;
 FileOfs := MemW[DevSeg: DevOfs + 04];
 FileSeg := MemW[DevSeg: DevOfs + 06];
 Finished := False;
 FileHandles := 00;
 If (FileSeg = $FFFF) AND (FileOfs = $FFFF) then
  FileHandles := MemW[PrefixSeg: $32]
   else Repeat;
          TempOfs := MemW[FileSeg: FileOfs];
          TempSeg := MemW[FileSeg: FileOfs + 02];
          FileHandles := FileHandles + MemW[FileSeg:FileOfs+ 04];
          If TempOfs=$FFFF then
           Finished := True
            else Begin;
                   FileSeg := TempSeg;
                   FileOfs := TempOfs;
                 End;
        Until Finished;


 GetFiles := FileHandles;
End; { func. GetFiles }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetUsedFiles: Word;
Var UsedHandles : Word;
    FileSeg,
    FileOfs     : Word;
Begin;
 UsedHandles := 00;
 FileOfs := MemW[PrefixSeg: $36];
 FileSeg := MemW[PrefixSeg: $34];
 While Mem[FileOfs: FileSeg] < $FF do
  Begin;
   Inc(UsedHandles);
   Inc(FileSeg);
  End; { While }
 GetUsedFiles := UsedHandles;
End; { func. GetUsedFiles }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ShowOsInfo;
Begin;
 Writeln('Operating System and Version        : ',ShowOSVersion);
 Writeln('Real OS version                     : ',ShowRealVersion);
 Writeln('OEM Serial Number                   : ',ShowOemNumber);
 Writeln('Date                                : ',ShowDate, ' / ', ShowTime);
 Writeln('DOS Flags');
 Writeln(' CTRL-Break checkking               : ',Bool2On(CtrlBreakState));
 Writeln(' Verify (disk writes) setting       : ',Bool2On(VerifyState));
 Writeln(' Reset computer                     : ',GetReset);
 Writeln(' Boot Drive                         : ',GetBootdrive,':');
 Writeln(' PrintScreen Status                 : ',GetPrintScreenStatus);
 Writeln(' Memory Fitting                     : ',GetMemoryFit);
 Writeln(' Buffers                            : ',GetBuffers);
 Writeln(' Files                              : ',GetFiles);
 Writeln(' Files used                         : ',GetUsedFiles);
End;
