uses
     Drivers,

     skMHLapi,
     gStream,

     skMHL,
     skCommon,

     {$IFDEF WIN32}
     skComnD3,
     {$ELSE}
     skComnTV,
     {$ENDIF}

     skOpen;

const
 Version = '1.01';
 Attributes: Array[1..16] Of Longint = (maPrivate, maCrash,  maReceived,
                                        maSent,    maAttach, maTransit,
                                        maOrphan,  maKill,   maLocal,
                                        maHold,    maFRq,    maRRq,
                                        maRRc,      maARq,   maURq,
                                        maScanned);

function Long2Str(L: Longint): String;
 var
  S: String;
 begin
  Str(L, S);

  Long2Str:=S;
 end;

var
 Current, Total: Longint;

procedure Slider;
 var
  K: Longint;
 begin
  K:=Round(Current / Total * 100);

  if K < 0 then
   K:=0;

  if K > 100 then
   K:=100;

  PrintStr(Concat(#13, Long2Str(K), '%: ', Long2Str(Current), ' of ', Long2Str(Total)));
 end;

var
 Source, Destination: PMessageBase;
 A, B: PMessageBaseStream;
 FromAddress, ToAddress: TAddress;
 DateTime: TMessageBaseDateTime;
 Move, Error: Boolean;
 Event: TEvent;
 K: Longint;
 S: String;
begin
 skMHLapiInit;

 InstallMHLcommon;

 PrintStr(Concat(#13'sk''s message base converter, v', Version, ' (q) by sk // [rAN], 1998-2000.'#13#10));
 PrintStr('based on ' + skmhlapiFullTitle + '.'#13#10#13#10);

 if ParamCount < 2 then
  begin
   PrintStr('syntax: skmsgcvt TYPEsource TYPEdestination [/move]'#13#10#13#10);
   PrintStr('   jam: Jf:\fido\areas\jopa'#13#10);
   PrintStr('squish: Sf:\fido\areas\jopa2'#13#10);
   PrintStr('   msg: Ff:\fido\areas\jopa3.msg\'#13#10);
   PrintStr('hudson: sucks'#13#10);

   Halt(255);
  end;

 if ParamCount > 2 then
  begin
   S:=ParamStr(3);

   if S[1] in ['/', '-'] then
    Delete(S, 1, 1);

   for K:=1 to Length(S) do
    S[K]:=UpCase(S[K]);

   Move:=S = 'MOVE';

   if not Move then
    begin
     PrintStr(Concat('unknown switch "', ParamStr(3), '"'));

     Halt(254);
    end;
  end
 else
  Move:=False;

 if not OpenMessageBase(Source, ParamStr(1)) then
  begin
   PrintStr('unable to open source');

   Halt(253);
  end;

 if not OpenOrCreateMessageBase(Destination, ParamStr(2)) then
  begin
   CloseMessageBase(Source);

   PrintStr('unable to open/create destination');

   Halt(252);
  end;

 PrintStr(Concat('"', ParamStr(1), '" treated as source, '));
 PrintStr(Concat('"', ParamStr(2), '" treated as destination'));

 if Move then
  PrintStr(', moving');

 PrintStr(#13#10#13#10);

 PrintStr(Concat(Long2Str(Source^.GetCount), ' message(s) to convert'#13#10#13#10));

 Total:=Source^.GetCount;

 Current:=0;

 Error:=False;

 Source^.Seek(1);

 while Source^.SeekFound do
  begin
   Inc(Current);

   Slider;

   if not Source^.OpenMessage then
    begin
     PrintStr(Concat('unable to open message #', Long2Str(Source^.Current), ', rc=#', Long2Str(Source^.GetStatus), #13#10));

     Error:=True;

     Break;
    end
   else
    begin
     if not Destination^.CreateNewMessage then
      begin
       Source^.CloseMessage;

       PrintStr(Concat('unable to create message, rc=#', Long2Str(Destination^.GetStatus), #13#10));

       Error:=True;

       Break;
      end;

     A:=New(PMessageBaseStreamThunk, Init(Source^.GetMessageTextStream, @skmhlapiGatewayMHL, False));
     B:=New(PMessageBaseStreamThunk, Init(Destination^.GetMessageTextStream, @skmhlapiGatewayMHL, False));

     A^.Seek(0);

     with B^ do
      begin
       Seek(0);

       CopyFrom(A^, A^.GetSize);

       Truncate;

       Flush;
      end;

     Dispose(B, Done);
     Dispose(A, Done);

     Destination^.SetFrom(Source^.GetFrom);
     Destination^.SetTo(Source^.GetTo);
     Destination^.SetSubject(Source^.GetSubject);
     Source^.GetFromAndToAddress(FromAddress, ToAddress);
     Destination^.SetFromAndToAddress(FromAddress, ToAddress, False);

     Source^.GetWrittenDateTime(DateTime);
     Destination^.SetWrittenDateTime(DateTime);
     Source^.GetArrivedDateTime(DateTime);
     Destination^.SetArrivedDateTime(DateTime);

     for K:=Low(Attributes) to High(Attributes) do
      Destination^.SetAttribute(Attributes[K], Source^.GetAttribute(Attributes[K]));

     if not Destination^.WriteMessage then
      begin
       Source^.CloseMessage;

       PrintStr(Concat('unable to write message, rc=#', Long2Str(Destination^.GetStatus), #13#10));

       Error:=True;

       Break;
      end;

     Destination^.CloseMessage;
     Source^.CloseMessage;

     if Move and not Source^.KillMessage then
      begin
       PrintStr(Concat('unable to kill message, rc=#', Long2Str(Source^.GetStatus), #13#10));

       Source^.Seek(Source^.Current - 1);

       Error:=True;
      end;
    end;

   Slider;

   Source^.SeekNext;

   GetKeyEvent(Event);

   if (Event.What = evKeyDown) and (Event.KeyCode = kbEsc) then
    begin
     PrintStr(' cancelled');

     Error:=True;

     Break;
    end;
  end;

 PrintStr(#13#10#13#10);

 if not Error then
  PrintStr('done'#13#10);

 CloseMessageBase(Destination);
 CloseMessageBase(Source);
end.
